/*jslint node: true */
"use strict";

var crypto = require("crypto");
var config = require('./config.json');

// Equivalent to the PHP hash_hmac function
function hash_hmac(algo, data, key) {
  return crypto.createHmac(algo, key).update(data).digest("hex");
}

// Equivalent to the PHP time function
function time() {
  return Math.floor(new Date() / 1000);
}

module.exports = {
  getSignedUrl : function (req, res) {
    // Timestamp the incoming URL
    var url = req.query.url + "&ts=" + time();

    // Sign the time-stamped URL
    url += "&ds=" + hash_hmac('md5', url, config.secretkey);

    // return the resulting URL as a JSON string
    res.send(JSON.stringify({
      url : url
    }));
  }
};
